#ifndef DB_RESULT_FILE_H
#define DB_RESULT_FILE_H

#include "ResultFile.h"
#ifdef linux
#include <db1/db.h>
#else
#include <db.h>
#endif

#include <sys/types.h>

class DBResultFile {
public:
    static DBResultFile* open( const char* filename );
    static DBResultFile* open( const char* filename, int flags );
    virtual ~DBResultFile();
    virtual int close();
    virtual int flush();

    /**
     * malloc()s. caller's responsibility.
     */
    virtual Result* get( int choices, int voters, float error );

    virtual int put( Result* it, int choices, int voters, float error );

    virtual int useNames( const NameBlock* namesIn );

    virtual int useStrategyNames( const NameBlock* namesIn );

    DBT systemNames;
    DBT errorSteps;
    DBT choiceSteps;
    DBT voterSteps;
    DBT strategyDBT;
    NameBlock names;
    NameBlock strategyNames;
    int resultDBVersion;
    inline int numSystems() { return names.nnames; }
    inline int numStrategies() { return strategyNames.nnames; }
/*protected:*/
    DBResultFile( void* dbIn );
    int openInit();
    DB* db;
};

class ResultKeyStruct {
public:
    int32_t choices;
    int32_t voters;
    float error;
    ResultKeyStruct( int32_t c, int32_t v, float e );
    inline ResultKeyStruct(){};
};

#endif
