#!/usr/bin/perl -w
$fin = *STDIN;
open FOUT, ">-";
# no filename leaves input to STDIN
$filename = "";
$noVoteVal = "<td></td>";
$numChoices = 0;
$offset = 0;

while ( $arg = shift ) {
 if ( $arg eq "-c" ) {
  $numChoices = shift;
 } elsif ( $arg eq "-s" ) {
  $offset = shift;
 } elsif ( $arg eq "-f" ) {
  $filename = shift;
 } elsif ( $arg eq "-b" ) {
  $noVoteVal = shift;
 } elsif ( $arg eq "-o" ) {
  $outname = shift;
  open FOUT, $outname;
 } else {
  print "unknown arg \"$arg\"\n";
  exit 1;
 }
}

# unescape URL-encoded data
sub unescape {
#shift() if ref($_[0]) || (defined $_[1] && $_[0] eq $DefaultClass);
 my $todecode = shift;
 return undef unless defined($todecode);
 $todecode =~ tr/+/ /;       # pluses become spaces
 $todecode =~ s/%([0-9a-fA-F]{2})/pack("c",hex($1))/ge;
 return $todecode;
}

if ( $filename ) {
 open $fin, "$filename";
}
print FOUT "<table border=\"1\">\n";
while ( $a = <$fin> ) {
 @b = split '&', $a;
 %e = ();
 $other = "";
 foreach $c ( @b ) {
  if ( $c !~ /=/ ) {
   if ( $other ) {
    $other = $other . "," . $c;
   } else {
    $other = $c;
   }
  } else {
   ($name,$val) = split '=', $c;
   $e{$name} = $val;
  }
 }
 print FOUT "<tr>";
 $val = $e{"REMOTE_ADDR"};
 print FOUT "<td align=\"right\">$val</td>";
 for ( $i = $offset; $i < $numChoices + $offset; $i++ ) {
  $val = $e{"$i"};
  if ( $val ) {
   $val = unescape($val);
   if ( $val eq "on" ) {
    $val = 1;
   }
   print FOUT "<td>$val</td>";
  } else {
   print FOUT $noVoteVal;
  }
 }
 $val = $e{"HTTP_USER_AGENT"};
 print FOUT "<td>$val</td>";
 print FOUT "<td>$other</td>";
 print FOUT "</tr>\n";
}
print FOUT "</table>\n";
close FOUT;

