#!/usr/bin/perl -w
$fin = *STDIN;
# no filename leaves input to STDIN
$filename = "";
$noVoteVal = "0";
$numChoices = 0;
$offset = 0;

while ( $arg = shift ) {
 if ( $arg eq "-c" ) {
  $numChoices = shift;
 } elsif ( $arg eq "-s" ) {
  $offset = shift;
 } elsif ( $arg eq "-f" ) {
  $filename = shift;
 } elsif ( $arg eq "-b" ) {
  $noVoteVal = shift;
 } else {
  print "unknown arg \"$arg\"\n";
  exit 1;
 }
}

# unescape URL-encoded data
sub unescape {
#shift() if ref($_[0]) || (defined $_[1] && $_[0] eq $DefaultClass);
 my $todecode = shift;
 return undef unless defined($todecode);
 $todecode =~ tr/+/ /;       # pluses become spaces
 $todecode =~ s/%([0-9a-fA-F]{2})/pack("c",hex($1))/ge;
 return $todecode;
}

if ( $filename ) {
 open $fin, "$filename";
}
while ( $a = <$fin> ) {
 @b = split '&', $a;
 %e = ();
 foreach $c ( @b ) {
  ($name,$val) = split '=', $c;
  $e{$name} = $val;
 }
 for ( $i = $offset; $i < $numChoices + $offset; $i++ ) {
  $val = $e{"$i"};
  if ( $val ) {
   $val = unescape($val);
   if ( $val eq "on" ) {
    $val = 1;
   }
   print "$val";
  } else {
   print $noVoteVal;
  }
  if ( $i != $numChoices + $offset ) {
   print "\t";
  }
 }
 print "\n";
}
