#!/usr/bin/perl -w
# usage:
# makeForm.pl [-t|-p|-c] [-f|-F] [-a offset] choice-list-file ...
#
# where a choice-list-file has different choices listed on separate lines.
# The included file "formCandidates" is an example of this
#
# configuration variables. convenient to have things here.

$rankIntro = "<p>Rank the following choices. \"1\" for the most preferred choice, \"2\" for a second most preferred choice, and so on. Leaving some choices blank is OK, and indicates a minimum level of preference.</p>\n";

$acceptIntro = "<p>Check each of the choices below that is acceptable to you. It is OK to vote for as many as all of them or as few as none of them.</p>\n";

$cgiUrl = "/cgi-bin/ballotbox.pl";

# if true, output <html> to </html>, otherwise just the <form>...</form>
$fullHtml = 01;
$fullForm = 01;

# only the first of these that is nonzero will be used
$textInputMode = 0;
$popupMenuMode = 0;
$checkboxMode = 01;

$offset = 0;

$tableMode = 0;

$outname = "-";

@issueList = ();

while ( $a = shift ) {
  if ( $a eq "-t" ) {
    $textInputMode = 1;
  } elsif ( $a eq "-o" ) {
    $outname = shift;
  } elsif ( $a eq "-i" ) {
    $a = shift;
    push @issueList, $a;
  } elsif ( $a eq "-table" ) {
    $tableMode = 1;
  } elsif ( $a eq "-cgi" ) {
    $cgiUrl = shift;
  } elsif ( $a eq "-p" ) {
    $popupMenuMode = 1;
  } elsif ( $a eq "-c" ) {
    $checkboxMode = 1;
  } elsif ( $a eq "-f" ) {
    $fullHtml = 0;
    $fullForm = 1;
  } elsif ( $a eq "-F" ) {
    $fullHtml = 0;
    $fullForm = 0;
  } elsif ( $a eq "-a" ) {
    $offset = shift;
  } elsif ( $a eq "-rankIntro" ) {
    $rankIntro = shift;
  } elsif ( $a eq "-acceptIntro" ) {
    $acceptIntro = shift;
  } elsif ( $a eq "-noIntro" ) {
    $rankIntro = "";
    $acceptIntro = "";
  } else {
    print STDERR "bogus arg \"$a\"\n";
#    $a = shift;
#    push @issueList, $a;
  }
}

open FOUT, ">$outname" or die "couldn't open output file $outname\n";
print STDERR "@issueList\n";
if ( $fullHtml ) {
 print FOUT "<html><head><title>voting form</title></head><body>\n";
}
if ( $fullForm ) {
print FOUT "<form method=\"post\" action=\"" . $cgiUrl . "\">\n";
}
# a multiple issue ballot might be build by a foreach $issueValue ( issue list )
foreach $issueValue ( @issueList ) {
print FOUT "<fieldset><input type=\"hidden\" name=\"issue\" value=\"$issueValue\">\n";
@choices = ();
open FIN, "<$issueValue";
while ( $a = <FIN> ) {
  chomp $a;
  @choices = ( @choices, $a );
}
close FIN;
if ( $textInputMode || $popupMenuMode ) {
# form type 1, box to type ranking in next to each choice name
  print FOUT $rankIntro;
} elsif( $checkboxMode ) {
# form type 3, checkboxes for acceptance
  print FOUT $acceptIntro;
}
if ( $tableMode ) {
    print FOUT "<TABLE>";
}
for ( $ai = 0; $ai <= $#choices; $ai++ ) {
    $aii = $ai + $offset;
    if ( $tableMode ) {
	print FOUT "<TR><TD>";
    }
    if ( $textInputMode ) {
# form type 1, box to type ranking in next to each choice name
	print FOUT " <input type=\"TEXT\" name=\"$aii\"> " . $choices[$ai] . "<br>\n";
    } elsif ( $popupMenuMode ) {
# form type 2, popup menu per choice (more likely to have a clean parse on backend)
	print FOUT "<select name=\"$aii\"><option selected></option>";
	for ( $ri = 1; $ri <= $#choices + 1; $ri++ ) {
	    print FOUT "<option>$ri</option>";
	}
#  print FOUT "<select>";
	print FOUT "</select> " . $choices[$ai] . "<br>\n";
    } elsif( $checkboxMode ) {
# form type 3, checkboxes for acceptance
	print FOUT " <input type=\"checkbox\" name=\"$aii\"> " . $choices[$ai] . "<br>\n";
    }
    if ( $tableMode ) {
	print FOUT "</TD></TR>\n";
    }
}
if ( $tableMode ) {
    print FOUT "</TABLE>";
}
print FOUT "</fieldset>\n";
}
# close
if ( $fullForm ) {
print FOUT "<input type=\"SUBMIT\" value=\"Vote\">\n";
print FOUT "</form>\n";
}
if ( $fullHtml ) {
 print FOUT "</body></html>\n";
}
