package org.bolson.vote;
import java.util.Vector;

/**
 * Implements the Instant Runoff Voting, also known as Single Transferrable Vote.
 * DO NOT USE
 * IRV has achieved some popularity, but is mathematically flawed.
 * See <a href="http://bolson.org/voting/">my website</a> for details.
 * Any of the other systems offered by this package are preferred.
 * @deprecated
 */
public class IRV extends RankedVotingSystem {
    public IRV( int numCandidates ) {
	super( numCandidates );
	talley = new int[numc];
	winnerBuckets = new Vector[numc + 1];
	active = new boolean[numc];
	for ( int i = 0; i < numc; i++ ) {
	    talley[i] = 0;
	    winnerBuckets[i] = new Vector();
	    active[i] = true;
	}
	winnerBuckets[numc] = new Vector();
    }

    static boolean nodebug = true;
    protected void intoBucket( int ranking[] ) {
	int i;
	int mini = -1, min = numc + 1;
	StringBuffer sb = new StringBuffer("ranking{ ");
	for ( i = 0; i < numc; i++ ) {
	    if ( nodebug ) {
	    } else if ( ranking[i] != NO_VOTE ) {
		sb.append( ranking[i] );
	    } else {
		sb.append( '-' );
	    }
	    sb.append( ' ' );
	    if ( active[i] && (ranking[i] != NO_VOTE) && (ranking[i] < min) ) {
		mini = i;
		min = ranking[i];
	    }
	}
	if ( ! nodebug ) {
	    sb.append( "} into bucket " ).append( mini );
	    System.out.println( sb );
	}
	if ( mini == -1 ) {
	    winnerBuckets[numc].addElement( ranking );
	} else {
	    talley[mini]++;
	    winnerBuckets[mini].addElement( ranking );
	}
    }
    public int voteRanking( int ranking[] ) {
	intoBucket( (int[])ranking.clone() );
	totalVotes++;
	return 0;
    }
    public void resetBuckets() {
	/*
	for ( int c = 0; c < numc; c++ ) {
	    talley[c] = 0;
	    active[c] = true;
	    IRVNode* cur;
	    IRVNode* next;
	    cur = winnerBuckets[c];
	    while ( cur != NULL ) {
		next = cur->next;
		cur->next = votes;
		votes = cur;
		cur = next;
	    }
	    winnerBuckets[c] = NULL;
	}
	int votecheck = 0;
	while ( votes ) {
	    IRVNode* n;
	    n = votes->next;
	    intoBucket( votes );
	    votecheck++;
	    votes = n;
	}
	*/
    }	
    public int[] getWinners() {
	int max;
	int min;
	int maxi = 0;
	int mini = 0;
	boolean loserTie = false;
	boolean winnerTie = false;
	int loseri = numc - 1;	// where to store next loser
	int winneri = 0;		// where to store next winner
	int i;

	choiceIndecies = new int[numc];
	while ( winneri < loseri ) {
	    max = Integer.MIN_VALUE;
	    min = Integer.MAX_VALUE;
	    for ( i = 0; i < numc; i++ ) if ( active[i] ) {
		int si = talley[i];//winnerBuckets[i].size();
		if ( si > max ) {
		    maxi = i;
		    max = si;
		    loserTie = false;
		} else if ( si == max ) {
		    loserTie = true;
		}
		if ( si < min ) {
		    mini = i;
		    min = si;
		    winnerTie = false;
		} else if ( si == min ) {
		    winnerTie = true;
		}
	    }
	    if ( talley[maxi] > totalVotes / 2 ) {
		//fprintf( stderr, "promoting majority winner %d with majority %d\n", maxi, talley[maxi] );
		choiceIndecies[winneri] = maxi;
		active[maxi] = false;
		winneri++;
		break;
	    } else for ( i = 0; i < numc; i++ ) if ( active[i] ) {
		if ( talley[i] == min ) {
		    //fprintf( stderr, "%d deactivated with tie for low score at %d, loseri %d, winneri %d\n", i, min, loseri, winneri );
		    choiceIndecies[loseri] = i;
		    loseri--;
		    active[i] = false;
		    for ( int ri = winnerBuckets[i].size() - 1; ri >= 0; ri-- ) {
			intoBucket( (int[])(winnerBuckets[i].remove( ri )) );
		    }
		}
	    }
	}
	if ( winneri != loseri ) {
	    System.err.println( "why am i here? winneri "+winneri+", loseri "+loseri+"\n" );
	} else {
	    boolean onlyOne = true;
	    for ( i = 0; i < numc; i++ ) if ( active[i] ) {
		choiceIndecies[winneri] = i;
		winneri++;
	    }
	}
	// count winners (who ties with first?)
	for ( numWinners = 1; (numWinners < talley.length) && (talley[numWinners-1] == talley[numWinners]); numWinners++ ) {}
	int toret[] = new int[numWinners];
	for ( i = 0; i < numWinners; i++ ) {
	    toret[i] = choiceIndecies[i];
	}
	return toret;
    }
    public String htmlSummary( String names[] ) {
	StringBuffer toret;
	int max;
	boolean in[] = new boolean[numc];
	int maxi = 0, i;
	for ( i = 0; i < numc; i++ ) {
	    in[i] = true;
	}
	if ( names != null ) {
	    toret = new StringBuffer( "<table><tr><th></th><th>IRV Best Vote</th></tr>\n" );
	} else {
	    toret = new StringBuffer( "<table><tr><th>Choice Index</th><th>IRV Best Vote</th></tr>\n" );
	}
	while ( true ) {
	    boolean done;
	    max = Integer.MIN_VALUE;
	    done = true;
	    for ( i = 0; i < numc; i++ ) {
		if ( in[i] && talley[i] > max ) {
		    done = false;
		    maxi = i;
		    max = talley[i];
		}
	    }
	    if ( done ) break;
	    i = maxi;
	    in[i] = false;
	    toret.append( "<tr><td>" );
	    if ( names != null ) {
		toret.append( names[i] );
	    } else {
		toret.append( i + 1 );
	    }
	    toret.append( "</td><td>" );
	    toret.append( talley[i] );
	    toret.append( "</td></tr>\n" );
	}
	toret.append( "</table>\n" );
	return toret.toString();
    }
    public String toString( String names[] ) {
	if ( names == null ) {
	    return toString();
	}
	StringBuffer toret = new StringBuffer();
	for ( int i = 0; i < numc; i++ ) {
	    toret.append( names[i] );
	    toret.append( '\t' );
	    toret.append( talley[i] );
	    toret.append( '\n' );
	}
	return toret.toString();
    }
    public String toString() {
	StringBuffer toret = new StringBuffer();
	for ( int i = 0; i < numc; i++ ) {
	    toret.append( talley[i] );
	    toret.append( '\n' );
	}
	return toret.toString();
    }

    protected Vector votes;
    protected Vector winnerBuckets[];
    int talley[];
    boolean active[];
    int totalVotes;
    int numWinners;
    int choiceIndecies[] = new int[numc];
}
