#!/usr/bin/perl -w
$outputPrefix = "graph/";

sub readData( $$$ ) {
my $c = shift;
my $v = shift;
my $n = shift;
my $fname = sprintf "c%02dv%dn%d", $c, $v, $n;
#print "opening \"$fname\"\n";
open( FIN, "$fname" ) || return;
my $a = <FIN>;
if ( ! $a ) {
  return;
}
chomp($a);
my @header = ();
my @data = ();
my $time = 0;
BLA: while ( $a = <FIN> ) {
    chomp $a;
    my @p = split '\t', $a;
    last BLA if ( $#p != 4 );
#    print "header @header\ndata @data\n";
#    @header = (@header , "$p[0] mean happiness","$p[0] happiness std dev");
    @header = (@header , "$p[0]","$p[0] happiness std dev");
    @data = (@data , $p[2], $p[4] );
}
($time) = $a =~ /(.*)u .*/;
return (\@header, \@data, $time);
}

@csteps = ( 2, 3, 4, 5, 6, 7, 8, 9, 11, 13, 16, 20, 25, 31, 38, 50, 65, 99 );
#@csteps = ( 8, 9 );
#@vsteps = ( 10, 100, 1000, 10000, 100000, 1000000 );
@vsteps = ( 10, 100, 1000, 10000, 100000 );
#@vsteps = ( 10000 );
$n = 10000;

#@both = readData( 02, 10, 10000 );
#@h = @{$both[0]};
#@d = @{$both[1]};
#print "HAHA\nheader @h\ndata @d\n";

#read all data
@timeByV = ();
@dataByV = ();
foreach $v ( @vsteps ) {
$dbcr = [];
$tbcr = [];
#@dataByC = ();
#@dataByC = @{$dbcr};
foreach $c ( @csteps ) {
    @both = readData( $c, $v, $n );
    if ( @both ) {
    @h = @{$both[0]};
#    @d = @{$both[1]};
#    print "read v $v c $c d @d\n";
#    @dataByC = (@dataByC, $both[1]);
    @{$dbcr} = (@{$dbcr}, $both[1]);
    @{$tbcr} = ( @{$tbcr}, $both[2] );
  }
}
@dataByV = (@dataByV, $dbcr);
@timeByV = (@timeByV, $tbcr);
#print "times v$v @{$tbcr}\n";
}

#print "dataByV \# $#dataByV @dataByV\n";


if ( 01 ) {
for ($hi = 0; $hi <= $#h; $hi = $hi + 2 ) {
my $col = $h[$hi];
#print "ouputting column $col\n";
for ($vi = 0; $vi <= $#vsteps; $vi++ ) {
    my $v = $vsteps[$vi];
    my $fname = $outputPrefix . "c_v" . $v . "n" . $n . $col;
    #print "data $fname\n";
    open FOUT, ">$fname";
    @dataByC = @{$dataByV[$vi]};
#    print "hi $hi vi $vi v $v dataByC @dataByC\n";
    for ( $ci = 0; $ci <= $#csteps; $ci++ ) {
        my $c = $csteps[$ci];
	if ( $dataByC[$ci] ) {
        @d = @{$dataByC[$ci]};
#        print "vi $vi ci $ci c $c\t$d[$hi]\n";
        print FOUT "$c\t$d[$hi]\t$d[$hi + 1]\n";
      }
    }
    close FOUT;
}
}
}

if ( 01 ) {
for ($hi = 0; $hi <= $#h; $hi = $hi + 2 ) {
my $col = $h[$hi];
for ( $ci = 0; $ci <= $#csteps; $ci++ ) {
    my $c = $csteps[$ci];
    my $fname = sprintf "%sc%02dv_n%d%s", $outputPrefix, $c, $n, $col;
    #print "data $fname\n";
    open FOUT, ">$fname";
    for ($vi = 0; $vi <= $#vsteps; $vi++ ) {
        my $v = $vsteps[$vi];
        @dataByC = @{$dataByV[$vi]};
	if ( $dataByC[$ci] ) {
	  @d = @{$dataByC[$ci]};
#        print "vi $vi ci $ci v $v\t$d[$hi]\n";
        print FOUT "$v\t$d[$hi]\t$d[$hi + 1]\n";
	}
    }
    close FOUT;
}
}
}

if ( 01 ) {
  for ($vi = 0; $vi <= $#vsteps; $vi++ ) {
    my $v = $vsteps[$vi];
    my $fname = $outputPrefix . "time_v" . $v . "n" . $n;
    open FOUT, ">$fname";
    @dataByC = @{$timeByV[$vi]};
    for ( $ci = 0; $ci <= $#csteps; $ci++ ) {
      my $c = $csteps[$ci];
      if ( $dataByC[$ci] ) {
        $d = $dataByC[$ci];
        print FOUT "$c\t$d\n";
      }
    }
    close FOUT;
  }
}

@outputMode =
  (
   ["set terminal postscript landscape color solid\n",".ps"],
   ["set terminal postscript eps color solid\n",".eps"],
   ["set terminal png color\n",".png"]
  );


foreach $a ( @outputMode ) {
  #  print "\'@{$a}[0]\'@{$a}[1]\n";
  open GP, ">gnuplotCommandsC";

  for ( $ci = 0; $ci <= $#csteps; $ci++ ) {
    my $c = $csteps[$ci];
    #  print GP "set terminal png color\n";
    #  my $outputname = sprintf "%sc%02d.png", $outputPrefix, $c;
    print GP @{$a}[0];
    my $outputname = sprintf "%sc%02d%s", $outputPrefix, $c, @{$a}[1];
    print GP "set output \"" . $outputname . "\"\n";
    #  print GP "set size .75,.75\n";
    print GP "set logscale yx\n";
    print GP "set data style linespoints\n";
    print GP "set xlabel \"Number of Voters\"\n";
    print GP "set ylabel \"Happiness\"\n";
    print GP "set title \"$c Candidates\"\n";
    print GP "plot \\\n";
    for ($hi = 0; $hi <= $#h; $hi = $hi + 2 ) {
      my $col = $h[$hi];
      my $fname = sprintf "%sc%02dv_n%d%s", $outputPrefix, $c, $n, $col;
      if ( $hi + 2 > $#h ) {
	print GP "\'$fname\' title \"$col\"\n";
      } else {
	print GP "\'$fname\' title \"$col\", \\\n";
      }
    }
  }

  close GP;

  open GP, ">gnuplotCommandsT";
  print GP @{$a}[0];
  print GP "set output \"" . $outputPrefix . "time" . @{$a}[1] . "\"\n";
  #  print GP "set size .75,.75\n";
  print GP "set logscale xy\n";
  print GP "set data style linespoints\n";
  print GP "set xlabel \"Number of Candidates\"\n";
  print GP "set ylabel \"Seconds CPU Time\"\n";
  print GP "set title \"$n Simulated Elections\"\n";
  print GP "plot \\\n";
  for ($vi = 0; $vi <= $#vsteps; $vi++ ) {
    my $v = $vsteps[$vi];
    my $fname = $outputPrefix . "time_v" . $v . "n" . $n;
    if ( $vi + 1 > $#vsteps ) {
      print GP "\'$fname\' title \"$v Voters\"\n";
    } else {
      print GP "\'$fname\' title \"$v Voters\", \\\n";
    }
  }
  close GP;

  open GP, ">gnuplotCommandsV";
  for ($vi = 0; $vi <= $#vsteps; $vi++ ) {
    my $v = $vsteps[$vi];
    print GP @{$a}[0];
    print GP "set output \"" . $outputPrefix . "v" . $v . @{$a}[1] . "\"\n";
    #  print GP "set size .75,.75\n";
    print GP "set logscale x\n";
    print GP "set data style linespoints\n";
    print GP "set xlabel \"Number of Candidates\"\n";
    print GP "set ylabel \"Happiness\"\n";
    print GP "set title \"$v Voters\"\n";
    print GP "plot \\\n";
    for ($hi = 0; $hi <= $#h; $hi = $hi + 2 ) {
      my $col = $h[$hi];
      my $fname = $outputPrefix . "c_v" . $v . "n" . $n . $col;
      if ( $hi + 2 > $#h ) {
	print GP "\'$fname\' title \"$col\"\n";
      } else {
	print GP "\'$fname\' title \"$col\", \\\n";
      }
    }
  }
  close GP;

  system "gnuplot gnuplotCommandsC";
  system "gnuplot gnuplotCommandsV";
  system "gnuplot gnuplotCommandsT";

}
    for ($hi = 0; $hi <= $#h; $hi = $hi + 2 ) {
      my $col = $h[$hi];
      #print "cleaning column $col\n";
      for ( $ci = 0; $ci <= $#csteps; $ci++ ) {
	my $c = $csteps[$ci];
	my $fname = sprintf "%sc%02dv_n%d%s", $outputPrefix, $c, $n, $col;
	unlink $fname;
      }
      for ($vi = 0; $vi <= $#vsteps; $vi++ ) {
	my $v = $vsteps[$vi];
	my $fname = $outputPrefix . "c_v" . $v . "n" . $n . $col;
	unlink $fname;
      }
    }
    for ($vi = 0; $vi <= $#vsteps; $vi++ ) {
      my $v = $vsteps[$vi];
      my $fname = $outputPrefix . "time_v" . $v . "n" . $n;
      unlink $fname;
    }


unlink "gnuplotCommandsC";
unlink "gnuplotCommandsV";
unlink "gnuplotCommandsT";

# things to run:
# ./vdataToGnuplotdata.pl ; display graph/c*.png ; display graph/v*.png
