#!/usr/bin/perl -w
#use Steps;
#chdir "graph" or die "no graph/";
$outputPrefixP = "graph/";

$imgsize = "width=\"960\" height=\"720\"";

$vp = $outputPrefixP . "v";
@vs = <$vp*>;
print "vs @vs\n";
%vh = ();
foreach $vv ( @vs ) {
    ($v) = $vv =~ /v([[:digit:]]*)/;
    if ( $v ) {
	$vh{$v} = 1;
    }
}
@vsteps = sort( keys %vh );
print "vsteps @vsteps\n";

foreach $vpc ( "v", "cv", "rv" ) {
VLOOP: foreach $vi ( @vsteps ) {
    $outputPrefix = $outputPrefixP . $vpc . $vi;
    @f = <$outputPrefix/c*.png>;
    %ch = ();
    foreach $ff ( @f ) {
	( $c ) = $ff =~ /\/c([[:digit:]]*).png/;
	if ( $c ) {
	    $ch{$c} = 1;
	}
    }
    @csteps = sort( keys %ch );
#    if ( ! @csteps ) {
#	print "no csteps\n";
#	last VLOOP;
#    }
    @f = <$outputPrefix/e*.png>; 
    %eh = ();
    foreach $ff ( @f ) {
	( $e ) = $ff =~ /\/e(.*).png/;
	if ( $e ) {
	    $eh{$e} = 1;
	}
    }
    @esteps = sort( keys %eh );
#    if ( ! @esteps ) {
#	print "no esteps\n";
#	last VLOOP;
#    }
#    print "csteps \"@csteps\"\n";
#    print "esteps \"@esteps\"\n";

    if ( @csteps || @esteps ) {
	open FS, ">$outputPrefix/index.html";
	print FS "<html><head><title>Graphs With $vi Voters</title><META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW,NOINDEX\"></head><body bgcolor=\"#ffffff\"><h1>Graphs With $vi Voters</h1>\n";
	foreach $ei ( @esteps ) {
	    print FS "<hr><img src=\"e$ei.png\" $imgsize>\n";
	}
	foreach $ci ( @csteps ) {
	    printf FS "<hr><img src=\"c%02d.png\" $imgsize>\n", $ci;
	}
	print FS "</body></html>\n";
	close FS;
    }
}
}
$thline = "<tr><th>Group</th><th>Average Happiness (higher better)</th><th>Reliability (std dev, lower better)</th><th>Consensus (std dev, lower better)</th></tr>\n";
foreach $vi ( @vsteps ) {
    $counter = 0;
    $useit = ($counter == 0);
    $outputPrefix = $outputPrefixP . "v" . $vi;
    open FS, ">$outputPrefix.html";
    open FSA, ">$outputPrefix" . "all.html";
    print FS "<html><head><title>Graphs With $vi Voters</title><META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW,NOINDEX\"></head><body bgcolor=\"#ffffff\"><h1>Graphs With $vi Voters</h1>\n";
    print FS "<p>These are only a few of the graphs available. There are graphs based on every tested error amount and number of candidates <a href=\"v$vi"."all.html\">here.</a>\n";
    print FS "<table border=\"1\">";
    print FSA "<html><head><title>Graphs With $vi Voters</title><META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW,NOINDEX\"></head><body bgcolor=\"#ffffff\"><h1>Graphs With $vi Voters</h1>\n";
    print FSA "<table border=\"1\">";
    if ( @esteps ) {
	print FS "$thline";
	print FSA $thline;
    }
    foreach $ei ( @esteps ) {
	$line = "<tr><th>Error $ei</th><td><img src=\"v$vi/e$ei.png\" $imgsize></td>" .
	    "<td><img src=\"rv$vi/e$ei.png\" $imgsize></td>" .
	    "<td><img src=\"cv$vi/e$ei.png\" $imgsize></td></tr>\n";
	if ( $useit ) {
	    print FS $line;
	}
	$counter = ($counter + 1) % 4;
	$useit = ($counter == 0);
	print FSA $line;
    }
    if ( @csteps ) {
	print FS "$thline";
	print FSA $thline;
    }
    $counter = 0; $useit = 1;
    foreach $ci ( @csteps ) {
	my $imgname = sprintf "c%02d.png", $ci;
	$line = "<tr><th>$ci Choices</th><td><img src=\"v$vi/$imgname\" $imgsize></td>" .
	"<td><img src=\"rv$vi/$imgname\" $imgsize></td>" .
	"<td><img src=\"cv$vi/$imgname\" $imgsize></td></tr>\n";
	if ( $useit ) {
	    print FS $line;
	}
	$counter = ($counter + 1) % 4;
	$useit = ($counter == 0);
	print FSA $line;
    }
    if ( @csteps || @esteps ) {
	print FS "$thline";
	print FSA $thline;
    }
    print FS "</table>\n";
    print FS "</body></html>\n";
    print FSA "</table>\n";
    print FSA "</body></html>\n";
    close FS;
    close FSA;
}

$outputPrefix = $outputPrefixP . "v";
@they = <$outputPrefix*/c*.png>;
%ch = ();
foreach $ff ( @they ) {
    ( $c ) = $ff =~ /c(.*).png/;
    if ( $c ) {
	$ch{$c} = 1;
    }
}
@csteps = sort( keys %ch );
$outputPrefix = $outputPrefixP . "c";
foreach $ci ( @csteps ) {
    $cs = sprintf "%02d", $ci;
    open FOUT, ">$outputPrefix$cs.html";
    print FOUT "<html><head><title>Graphs With $ci Choices</title><META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW,NOINDEX\"></head><body bgcolor=\"#ffffff\"><h1>Graphs With $ci Choices</h1>\n";
    print FOUT "<table border=\"1\">$thline";
    foreach $vi ( @vsteps ) {
	$file = $outputPrefixP . "v$vi/c$ci.png";
	if ( -r $file ) {
	    $imgname = "c$ci.png";
	    print FOUT "<tr><th>$vi Voters</th><td><img src=\"v$vi/$imgname\" $imgsize></td>" .
	    "<td><img src=\"rv$vi/$imgname\" $imgsize></td>" .
	    "<td><img src=\"cv$vi/$imgname\" $imgsize></td></tr>\n";
	}
    }
    print FOUT "$thline</table></body></html>\n";
    close FOUT;
}
$outputPrefix = $outputPrefixP . "v";
@f = <$outputPrefix*/e*.png>; 
%eh = ();
foreach $ff ( @f ) {
    ( $e ) = $ff =~ /e(.*).png/;
    if ( $e ) {
	$eh{$e} = 1;
    }
}
@esteps = sort( keys %eh );
$outputPrefix = $outputPrefixP . "e";
foreach $ei ( @esteps ) {
    open FOUT, ">$outputPrefix$ei.html";
    print FOUT "<html><head><title>Graphs With $ei Error</title><META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW,NOINDEX\"></head><body bgcolor=\"#ffffff\"><h1>Graphs With $ei Error</h1>\n";
    print FOUT "<table border=\"1\">$thline";
    foreach $vi ( @vsteps ) {
	$file = $outputPrefixP . "v$vi/e$ei.png";
	if ( -r $file ) {
	    $imgname = "e$ei.png";
	    print FOUT "<tr><th>$vi Voters</th><td><img src=\"v$vi/$imgname\" $imgsize></td>" .
	    "<td><img src=\"rv$vi/$imgname\" $imgsize></td>" .
	    "<td><img src=\"cv$vi/$imgname\" $imgsize></td></tr>\n";
	}
    }
    print FOUT "$thline</table></body></html>\n";
    close FOUT;
}

$file = $outputPrefixP . "index.html";
open FOUT, ">$file";
print FOUT "<html><head><title>Graphs</title><META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW,NOINDEX\"></head><body bgcolor=\"#ffffff\">\n";
print FOUT "<a href=\"../index.html\">Voting Simulation Home</a>\n";
print FOUT "<h1>Graphs By Voters</h1>\n";
foreach $vi ( @vsteps ) {
    $file = $outputPrefixP . "v$vi".".html";
    if ( -r $file ) {
	print FOUT "<a href=\"v$vi".".html\">$vi Voters</a>( choices or error vary )<br>\n";
    }
}
print FOUT "<h1>Graphs By Error</h1>\n";
foreach $ei ( @esteps ) {
    $file = $outputPrefixP . "e$ei.html";
    if ( -r $file ) {
	print FOUT "<a href=\"e$ei.html\">$ei Error</a>( choices or voters vary )<br>\n";
    }
}
print FOUT "<h1>Graphs By Choices</h1>\n";
foreach $ci ( @csteps ) {
    $cs = sprintf "%02d", $ci;
    $file = $outputPrefixP . "c$cs.html";
    if ( -r $file ) {
	print FOUT "<a href=\"c$cs.html\">$ci Choices</a>( error or voters vary )<br>\n";
    }
}
print FOUT "<hr><a href=\"../index.html\">Voting Simulation Home</a>\n<br><address><a href=\"http://bolson.org/email.html\">email bolson</a></address>\n";
print FOUT "</body></html>\n";
close FOUT;

