#!/usr/bin/perl -w

$outputPrefixP = "graph/";


sub readData( $$$ ) {
my $c = shift;
my $v = shift;
my $e = shift;
#my $n = shift;
my $fname = sprintf "v%d/c%02de%s", $v, $c, $e;
#print "opening \"$fname\"\n";
open( FIN, "$fname" ) || return;
my $a = <FIN>;
if ( ! $a ) {
  print "$fname empty\n";
  return;
}
chomp($a);
my @header = ();
my @data = ();
BLA: while ( $a = <FIN> ) {
    chomp $a;
    my @p = split '\t', $a;
    last BLA if ( $#p != 6 );
#    print "header @header\ndata @data\n";
#    @header = (@header , "$p[0] mean happiness","$p[0] happiness std dev");
    @header = (@header , [ "$p[0]","$p[0] happiness std dev","$p[0] consensus" ] );
    @data = (@data , [ $p[2], $p[4], $p[6] ] );
}
return (\@header, \@data);
}


@vs = <v*>;
print "vs @vs\n";
@vsteps = ();
foreach $vv ( @vs ) {
    ($v) = $vv =~ /v([[:digit:]]*)/;
    if ( $v ) {
	@vsteps = ( @vsteps, $v );
    }
}
print "vsteps @vsteps\n";

VLOOP: foreach $v ( @vsteps ) {
    @f = <v$v/c??e*>;
#    print "f \"@f\"\n";
    %ch = ();
    %eh = ();
    foreach $ff ( @f ) {
	( $c, $e ) = $ff =~ /c([[:digit:]]*)e(.*)/;
	if ( $c && $e ) {
	    $ch{$c} = 1;
	    $eh{$e} = 1;
	}
    }
    @csteps = sort( keys %ch );
    @esteps = sort( keys %eh );
    if ( ! @csteps ) {
	print "no csteps\n";
	last VLOOP;
    }
    if ( ! @esteps ) {
	print "no esteps\n";
	last VLOOP;
    }
    print "csteps \"@csteps\"\n";
    print "esteps \"@esteps\"\n";

  $outputPrefix = $outputPrefixP . "v" . $v;
  mkdir $outputPrefix;
  $outputPrefix = $outputPrefix . "/";
#read all data
  @dataByV = ();
  foreach $e ( @esteps ) {
    $dbcr = [];
#@dataByC = ();
#@dataByC = @{$dbcr};
    foreach $c ( @csteps ) {
      @both = readData( $c, $v, $e );
      if ( @both ) {
	@h = @{$both[0]};
#    @d = @{$both[1]};
#    print "read v $v c $c d @d\n";
#    @dataByC = (@dataByC, $both[1]);
	@{$dbcr} = (@{$dbcr}, $both[1]);
      } else {
	print "error: readData( $c, $v, $e ) failed\n";
	last VLOOP;
      }
    }
    @dataByV = (@dataByV, $dbcr);
  }

  if ( 01 ) {
    for ($hi = 0; $hi <= $#h; $hi = $hi + 1 ) {
      my @curh = @{$h[$hi]};
      my $col = $curh[0];
      #print "ouputting column $col\n";
      for ($ei = 0; $ei <= $#esteps; $ei++ ) {
	my $e = $esteps[$ei];
	my $fname = $outputPrefix . "c_v" . $v . "e$e". "$col";
	#print "data $fname\n";
	open FOUT, ">$fname" or die "fout";
	@dataByC = @{$dataByV[$ei]};
	#    print "hi $hi vi $vi v $v dataByC @dataByC\n";
	for ( $ci = 0; $ci <= $#csteps; $ci++ ) {
	  my $c = $csteps[$ci];
	  if ( $dataByC[$ci] ) {
            my @curd = @{$dataByC[$ci]};
	    my @d = @{$curd[$hi]};
            if ( (! $c) || (! @d) || (!$d[0]) || (! $d[1]) ) {
                print "what the hell is wrong c $c \"@d\"\n";
                last VLOOP;
            }
            #print "$c\t$d[0]\t$d[1]\n";
	    print FOUT "$c\t$d[0]\t$d[1]\n";
	  }
	}
	close FOUT;
      }
    }
  }

  if ( 01 ) {
    for ($hi = 0; $hi <= $#h; $hi = $hi + 1 ) {
      my @curh = @{$h[$hi]};
      my $col = $curh[0];
      for ( $ci = 0; $ci <= $#csteps; $ci++ ) {
	my $c = $csteps[$ci];
	my $fname = sprintf "%sc%02dv%de_%s", $outputPrefix, $c, $v, $col;
	#print "data $fname\n";
	open FOUT, ">$fname";
	for ($ei = 0; $ei <= $#esteps; $ei++ ) {
	  my $e = $esteps[$ei];
	  @dataByC = @{$dataByV[$ei]};
	  if ( $dataByC[$ci] ) {
            my @curd = @{$dataByC[$ci]};
	    my @d = @{$curd[$hi]};
	    #        print "vi $vi ci $ci v $v\t$d[$hi]\n";
	    print FOUT "$e\t$d[0]\t$d[1]\n";
	  }
	}
	close FOUT;
      }
    }
  }

@outputMode =
  (
   ["set terminal postscript landscape color solid\n",".ps"],
   ["set terminal postscript eps color solid\n",".eps"],
   ["set terminal png color\nset size 1.5,1.5\n",".png"]
  );


foreach $a ( @outputMode ) {
  #  print "\'@{$a}[0]\'@{$a}[1]\n";
  open GP, ">gnuplotCommandsC";

  for ( $ci = 0; $ci <= $#csteps; $ci++ ) {
    my $c = $csteps[$ci];
    #  print GP "set terminal png color\n";
    #  my $outputname = sprintf "%sc%02d.png", $outputPrefix, $c;
    print GP @{$a}[0];
    my $outputname = sprintf "%sc%02d%s", $outputPrefix, $c, @{$a}[1];
    print GP "set output \"" . $outputname . "\"\n";
#    print GP "set size 1.5,1.5\n";
    #  print GP "set logscale y\n";
    print GP "set data style linespoints\n";
    print GP "set xlabel \"Potential Error\"\n";
    print GP "set ylabel \"Happiness\"\n";
    print GP "set title \"$c Choices, $v Voters\"\n";
    print GP "plot \\\n";
    for ($hi = 0; $hi <= $#h; $hi = $hi + 1 ) {
      my @curh = @{$h[$hi]};
      my $col = $curh[0];
      my $fname = sprintf "%sc%02dv%de_%s", $outputPrefix, $c, $v, $col;
      if ( $hi + 1 > $#h ) {
	print GP "\'$fname\' title \"$col\"\n";
      } else {
	print GP "\'$fname\' title \"$col\", \\\n";
      }
    }
    print GP "\n";
  }

  close GP;

  open GP, ">gnuplotCommandsE";

  for ($ei = 0; $ei <= $#esteps; $ei++ ) {
    my $e = $esteps[$ei];
    print GP @{$a}[0];
    print GP "set output \"" . $outputPrefix . "e" . $e . @{$a}[1] . "\"\n";
#    print GP "set size 1.5,1.5\n";
    print GP "set logscale x\n";
    print GP "set data style linespoints\n";
    print GP "set xlabel \"Number of Choices\"\n";
    print GP "set ylabel \"Happiness\"\n";
    print GP "set title \"Potential Error = $e, $v Voters\"\n";
    print GP "plot \\\n";
    for ($hi = 0; $hi <= $#h; $hi = $hi + 1 ) {
      my @curh = @{$h[$hi]};
      my $col = $curh[0];
      my $fname = $outputPrefix . "c_v" . $v . "e" . $e . $col;
      if ( $hi + 1 > $#h ) {
	print GP "\'$fname\' title \"$col\"\n";
      } else {
	print GP "\'$fname\' title \"$col\", \\\n";
      }
    }
    print GP "\n";
  }

  close GP;

  system "gnuplot gnuplotCommandsC";
  system "gnuplot gnuplotCommandsE";

}
    for ($hi = 0; $hi <= $#h; $hi = $hi + 1 ) {
      my @curh = @{$h[$hi]};
      my $col = $curh[0];
      for ( $ci = 0; $ci <= $#csteps; $ci++ ) {
	my $c = $csteps[$ci];
	my $fname = sprintf "%sc%02dv%de_%s", $outputPrefix, $c, $v, $col;
	unlink $fname;
      }
      for ($ei = 0; $ei <= $#esteps; $ei++ ) {
	my $e = $esteps[$ei];
	my $fname = $outputPrefix . "c_v" . $v . "e$e". "$col";
	unlink $fname;
      }
    }
    @ps = <$outputPrefix*.ps>;
    foreach $p ( @ps ) {
	($pdf) = $p =~ /(.*)\.ps/;
	if ( $pdf ) {
	    system "ps2pdf13 $p $pdf.pdf";
	}
    }
}

unlink "gnuplotCommandsC";
unlink "gnuplotCommandsE";
