/*
 *  Max.cpp
 *  multiseat
 *
 *  Created by Brian Olson on Mon Sep 08 2003.
 *  Copyright (c) 2003 Brian Olson. All rights reserved.
 *
 */

#include "Max.h"

void Max::runElection( int* winnerR, int seats, const VoterArray& they ) {
    double* psum;
    int* rank;
    bool notdone = true;
    int numc = they.numc;
    psum = new double[numc];
    rank = new int[numc];

    for ( int s = 0; s < numc; s++ ) {
	psum[s] = 0;
	rank[s] = s;
    }
    for ( int v = 0; v < they.numv; v++ ) {
	Voter &cv = they[v];
	for ( int s = 0; s < numc; s++ ) {
	    psum[s] += cv.getPref(s);
	}
    }
    while ( notdone ) {
	notdone = false;
	for ( int s = 1; s < numc; s++ ) {
	    if ( psum[rank[s-1]] < psum[rank[s]] ) {
		int tr;
		tr = rank[s-1];
		rank[s-1] = rank[s];
		rank[s] = tr;
		notdone = true;
	    }
	}
    }
    for ( int s = 0; s < numc; s++ ) {
	winnerR[s] = rank[s];
    }
    delete psum;
    delete rank;
}

MultiseatElection* newMax() {
    return new Max();
}

static MEFactory randomFactory( newMax, "max" );

const char* Max::name() {
    return "Maximum";
}
