/*
 *  NormRatedTopN.cpp
 *  multiseat
 *
 *  Created by Brian Olson on Sun Oct 12 2003.
 *  Copyright (c) 2003 Brian Olson. All rights reserved.
 *
 */

#include "NormRatedTopN.h"

#include <math.h>
#include <stdlib.h>
#include <stdio.h>

void NormRatedTopN::runElection( int* winnerR, int seats, const VoterArray& they ) {
    double* psum;
    int* rank;
    bool notdone = true;
    int numc = they.numc;
    psum = new double[numc];
    rank = new int[numc];

    for ( int s = 0; s < numc; s++ ) {
	psum[s] = 0;
	rank[s] = s;
    }
    /* add up normalized votes */
    for ( int v = 0; v < they.numv; v++ ) {
	double abssum = 0.0;
	Voter &cv = they[v];
	for ( int c = 0; c < they.numc; c++ ) {
	    double p = cv.getPref(c);
	    abssum += fabs( p );
	}
	for ( int c = 0; c < they.numc; c++ ) {
	    double p = cv.getPref(c);
	    psum[c] += p / abssum;
	}
    }
    /* sort candidates based on preference sums */
    while ( notdone ) {
	notdone = false;
	for ( int s = 1; s < numc; s++ ) {
	    if ( psum[rank[s-1]] < psum[rank[s]] ) {
		int tr;
		tr = rank[s-1];
		rank[s-1] = rank[s];
		rank[s] = tr;
		notdone = true;
	    }
	}
    }
    for ( int s = 0; s < numc; s++ ) {
	winnerR[s] = rank[s];
    }
    delete psum;
    delete rank;
}

MultiseatElection* newNormRatedTopN() {
    return new NormRatedTopN();
}


static MEFactory NormRatedTopNFactory( newNormRatedTopN, "nrtn" );

const char* NormRatedTopN::name() {
    return "Normalized Rating, Top N";
}
