/*
 *  Random.cpp
 *  multiseat
 *
 *  Created by Brian Olson on Mon Sep 08 2003.
 *  Copyright (c) 2003 Brian Olson. All rights reserved.
 *
 */

#include "Random.h"
#include <stdlib.h>

void Random::runElection( int* winnerR, int seats, const VoterArray& they ) {
    for ( int s = 0; s < they.numc; s++ ) {
	winnerR[s] = s;
    }
    for ( int s = 0; s < they.numc; s++ ) {
	int x = random() % (they.numc - s);
	if ( x > 0 ) {
	    int tr;
	    tr = winnerR[s];
	    winnerR[s] = winnerR[s + x];
	    winnerR[s + x] = tr;
	}
    }
}

MultiseatElection* newRandom() {
    return new Random();
}


static MEFactory randomFactory( newRandom, "random" );

const char* Random::name() {
    return "Random";
}
