/*
 *  SimGlobal.cpp
 *  multiseat
 *
 *  Created by Brian Olson on Thu Sep 11 2003.
 *  Copyright (c) 2003 Brian Olson. All rights reserved.
 *
 */

#include "SimGlobal.h"
#include "MultiseatElection.h"

SimGlobal::SimGlobal()
: root( (MESystem*)0 ), nsys( 0 ),
drf( (DBResultFile*)0 ),
summary( 1 ),
printEachElection( 0 ),
goGently( 0 )
{}

void SimGlobal::add( MESystem* in ) {
    if ( ! in ) {
	return;
    }
    in->next = root;
    root = in;
}

void SimGlobal::reverseSystems() {
    MESystem* prev = 0;
    MESystem* cursys = root;
    MESystem* next;
    while ( cursys ) {
	next = cursys->next;
	cursys->next = prev;
	prev = cursys;
	cursys = next;
    }
    root = prev;
}
