#ifndef SIMWORKSTATE_H
#define SIMWORKSTATE_H
/*
 *  SimWorkState.h
 *  multiseat
 *
 *  Created by Brian Olson on Thu Sep 11 2003.
 *  Copyright (c) 2003 Brian Olson. All rights reserved.
 *
 */

class SimGlobal;
class WorkSource;
class WorkUnit;

#include "Voter.h"

class SimWorkState {
public:
    SimGlobal* g;
    WorkSource* q;

    int trials;
    double** happiness;	// double[nsys][trials]
    double* happisum;	// double[nsys]
    double* happistdsum;// double[nsys]

    int* winnerR;

    VoterArray they;
    int theyInitted;

    SimWorkState();

    void init();
    void runWu( WorkUnit* );
    void* run();

    void printElection( MESystem* cur, WorkUnit* wu, double happy );
};


extern "C" void* runSimWorkState( /*SimWorkState*/void* s );

#endif
